import { TooltipPositionType, TooltipSizeType, TooltipColorType } from "./constants";
export declare class GovTooltip {
    private h;
    private readonly tooltipContentId;
    private readonly tooltipId;
    constructor();
    host: HTMLGovTooltipElement;
    /**
     * Style variation of the tooltip
     */
    readonly color?: TooltipColorType;
    /**
     * Tooltip’s size.
     */
    readonly size?: TooltipSizeType;
    /**
     * Tooltip display position
     */
    position: TooltipPositionType;
    /**
     * Information contained in the tooltip
     */
    readonly message: string;
    /**
     * Custom tooltip identifier.
     */
    readonly identifier: string;
    /**
     * Trigger is just an icon
     */
    readonly icon: boolean;
    persist: boolean;
    validateColor(newValue: string): void;
    validateSize(newValue: string): void;
    validatePosition(newValue: string): void;
    rerenderMessage(): void;
    connectedCallback(): void;
    componentWillLoad(): void;
    componentDidUpdate(): void;
    disconnectedCallback(): void;
    private createContentWrapper;
    private get tooltipContent();
    private get insideContent();
    private registerListeners;
    private verifyPositionSpace;
    private showTooltip;
    private hideTooltip;
    private removeContent;
    render(): any;
    /**
     * Showing the modal
     */
    show(): Promise<void>;
    /**
     * Hiding the modal
     */
    hide(): Promise<void>;
}
